;;; $Id: maybe.tst,v 1.5 2006/01/30 03:13:29 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

(require (lib "maybe.scm" "typedscm"))

(run-regression-tests-equal?
 `(
    ( ((maybe-of number?) (make-something 3)) ==> #t )
    ( ((maybe-of number?) 3) ==> #f )
    ( (maybe-something? (make-something #f)) ==> #t )
    ( (maybe-nothing? (make-nothing)) ==> #t )
    ( (maybe-something? (make-nothing)) ==> #f )
    ( (maybe-nothing? (make-something #f)) ==> #f )
    ( (something->value (make-something 3)) ==> 3 )
    ( (something->value (make-something '(3 4 2))) ==> (3 4 2) )
    ( (maybe-test (make-something 342)
		  (lambda (v) v)
		  (lambda () -1))
      ==> 342 )
    ( (maybe-test (make-nothing)
		  (lambda (v) v)
		  (lambda () -1))
      ==> -1 )
    )
 )

