;;; $Id: tc-attrib-pair.scm,v 1.6 2006/01/30 03:13:29 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

;;; AUTHOR: Brian Dorn and Gary T. Leavens
;;;
;;;         ATTRIBUTED SYNTAX PAIRS      
;;; 
;;; Attributed syntax pairs are a pair
;;; that contains a piece of syntax and some kind of attribute.
;;; The : is the constructor for such pairs.

(module tc-attrib-pair (lib "typedscm.ss" "typedscm")

(provide tc:attrib-pair-of : tc:attrib-pair->syn tc:attrib-pair->type
         ;; all-from tc-tree.scm
         tc:tree-of tc:root tc:leaves tc:node 
         tc:print-map tc:tree-print)

(deftype tc:attrib-pair-of (type-predicate-for tc:attrib-pair))
(deftype : (forall (syn attr) (-> (syn attr) (tc:attrib-pair-of syn attr))))
(deftype tc:attrib-pair->syn
  (forall (syn attr) (-> ((tc:attrib-pair-of syn attr)) syn)))
(deftype tc:attrib-pair->type
  (forall (syn attr) (-> ((tc:attrib-pair-of syn attr)) attr)))

(require (lib "tc-tree.scm" "typedscm")
	 (lib "relax-type-checking.scm" "typedscm"))

(defrep
  (forall (syn attrib) (tc:attrib-pair-of syn attrib) (pair-of syn attrib)))

(define tc:attrib-pair-of
  (forall (Syn? Attr?) (pair-of Syn? Attr?)))

(define :
    (lambda (syn attr)
      (make-pair syn attr)))

(define tc:attrib-pair->syn
    (lambda (asp)
      (pair-first asp)))

(define tc:attrib-pair->type
    (lambda (asp)
      (pair-second asp)))

) ;; end module
