;;; $Id: tc-global-var-types.scm,v 1.12 2006/02/05 20:01:15 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

;;; Types for built-in Scheme procedures for use with Brian Dorn's
;;; incarnation of the type-checker
;;; AUTHORS: Brian Dorn and Gary Leavens based on earlier work with
;;;          Curtis Clifton and Steven L. Jenkins.

(module tc-global-var-types (lib "typedscm.ss" "typedscm")

(provide tc:global-var-types)

(deftype tc:global-var-types (-> () (tc:env-of symbol tc:type-expr)))
  
(require (lib "tc-global-var-output-types.scm" "typedscm")
         (lib "tc-env.scm" "typedscm")
	 (lib "tc-type-translate.scm" "typedscm")
	 (lib "relax-type-checking.scm" "typedscm"))

(deftype *tc:global-var-types* (tc:env-of symbol tc:type-expr))
(define *tc:global-var-types*
  (has-type-trusted
    (tc:env-of symbol tc:type-expr)
    #f))

(define tc:global-var-types
  (lambda ()
    (if (true? (not *tc:global-var-types*))
	(set! *tc:global-var-types*
	      (tc:env-map
	       (lambda (sym output-typ)
		 (tc:type-parse output-typ))
	       *tc:pre-global-var-output-type-env*)))
    *tc:global-var-types*))

) ;; end module
