;;; $Id: tc-qq-depth-stack.scm,v 1.4 2006/01/18 23:17:27 leavens Exp $
;;; Copyright (C) 2006 Iowa State University
;;;
;;; This file is part of Typedscm.
;;;
;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1,
;;; of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with Typedscm; see the file LesserGPL.txt.  If not,
;;; write to the Free Software Foundation, Inc., 51 Franklin St, Fifth
;;; Floor, Boston, MA 02110-1301 USA.

(module tc-qq-depth-stack (lib "typedscm.ss" "typedscm")

(provide tc:push-new-qq-depth-counter! tc:pop-qq-depth-stack!
	 tc:inc-top-of-qq-depth-stack! tc:dec-top-of-qq-depth-stack!
	 tc:top-of-qq-depth-stack)

(deftype tc:push-new-qq-depth-counter! (-> () void))
(deftype tc:pop-qq-depth-stack! (-> () void))
(deftype tc:inc-top-of-qq-depth-stack! (-> () void))
(deftype tc:dec-top-of-qq-depth-stack! (-> () void))
(deftype tc:top-of-qq-depth-stack (-> () number))

(deftype *tc:qq-depth-stack* (list-of number))
(define *tc:qq-depth-stack* '())

(define tc:push-new-qq-depth-counter!
  (lambda ()
    (set! *tc:qq-depth-stack* (cons 1 *tc:qq-depth-stack*))))
(define tc:pop-qq-depth-stack!
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (set! *tc:qq-depth-stack* (cdr *tc:qq-depth-stack*))))
(define tc:inc-top-of-qq-depth-stack!
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (set! *tc:qq-depth-stack* (cons (+ (car *tc:qq-depth-stack*) 1)
				    (cdr *tc:qq-depth-stack*)))))
(define tc:dec-top-of-qq-depth-stack!
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (set! *tc:qq-depth-stack* (cons (- (car *tc:qq-depth-stack*) 1)
				    (cdr *tc:qq-depth-stack*)))))
(define tc:top-of-qq-depth-stack
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (car *tc:qq-depth-stack*)))
)
